﻿using Newtonsoft.Json;
using System;

namespace Sunset.Library
{
    public static class ContentParser
    {
        public static bool CheckStatus(string jsonContent)
        {
            dynamic content = JsonConvert.DeserializeObject(jsonContent);
            return content.status == "OK";
        }

        public static string ParseSunsetString(string jsonContent)
        {
            if (!CheckStatus(jsonContent))
            {
                throw new ArgumentException("Status is not valid", nameof(jsonContent));
            }
            dynamic content = JsonConvert.DeserializeObject(jsonContent);
            return content.results.sunset;
        }

        public static string ParseSunriseString(string jsonContent)
        {
            if (!CheckStatus(jsonContent))
            {
                throw new ArgumentException("Status is not valid", nameof(jsonContent));
            }
            dynamic content = JsonConvert.DeserializeObject(jsonContent);
            return content.results.sunrise;
        }
    }
}
