﻿using Sunset.Interface;
using System;

namespace Sunset.Library
{
    public class SunsetCalculator : ISunsetCalculator
    {
        string cacheData = string.Empty;
        DateTime cacheDataDate = DateTime.MinValue;

        private ISolarService service;
        public ISolarService Service
        {
            get
            {
                if (service == null)
                    return new SolarService();
                return service;
            }
            set { service = value; }
        }


        private void ValidateCache(DateTime date)
        {
            if (cacheDataDate != date)
            {
                cacheData = Service.GetServiceData(date);
                cacheDataDate = date;
            }
        }

        public DateTime GetSunrise(DateTime date)
        {
            ValidateCache(date);
            string sunriseTime = ContentParser.ParseSunriseString(cacheData);
            return TimeHelpers.ToLocalTime(date, sunriseTime);
        }

        public DateTime GetSunset(DateTime date)
        {
            ValidateCache(date);
            string sunsetTime = ContentParser.ParseSunsetString(cacheData);
            return TimeHelpers.ToLocalTime(date, sunsetTime);
        }
    }
}
